package com.example.model;

@io.swagger.annotations.ApiModel(value = "AccountSummary")
@javax.xml.bind.annotation.XmlRootElement(name = "AccountSummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.AccountDetails.class, name = "AccountDetails"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AccountSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private com.example.model.Image logo = null;
	
	/**
	 */
	public AccountSummary id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public AccountSummary name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 * An image
	 */
	public AccountSummary logo(com.example.model.Image logo) {
		setLogo(logo);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "An image")
	@com.fasterxml.jackson.annotation.JsonProperty("logo")
	@javax.validation.Valid
	public com.example.model.Image getLogo() {
		return this.logo;
	}
	public void setLogo(com.example.model.Image logo) {
		this.logo = logo;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		AccountSummary accountSummary = (AccountSummary) o;
		return java.util.Objects.equals(this.id, accountSummary.id) &&
				java.util.Objects.equals(this.name, accountSummary.name) &&
				java.util.Objects.equals(this.logo, accountSummary.logo);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.logo);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AccountSummary {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    logo: ").append(toIndentedString(this.logo)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
