package com.example.model;

@io.swagger.annotations.ApiModel(value = "ParticipationCompletionError")
@javax.xml.bind.annotation.XmlRootElement(name = "ParticipationCompletionError")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ParticipationCompletionError implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Message implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@javax.xml.bind.annotation.XmlType(name = "CodeEnum")
		@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
		public enum CodeEnum {
			@javax.xml.bind.annotation.XmlEnumValue("ParticipationNotFound") PARTICIPATION_NOT_FOUND("ParticipationNotFound"), 
			@javax.xml.bind.annotation.XmlEnumValue("UnAnsweredQuestion") UN_ANSWERED_QUESTION("UnAnsweredQuestion"), 
			@javax.xml.bind.annotation.XmlEnumValue("ParticipationExpired") PARTICIPATION_EXPIRED("ParticipationExpired"), 
			@javax.xml.bind.annotation.XmlEnumValue("ParticipationAlreadyCompleted") PARTICIPATION_ALREADY_COMPLETED("ParticipationAlreadyCompleted"), 
			@javax.xml.bind.annotation.XmlEnumValue("SurveyNotAvailable") SURVEY_NOT_AVAILABLE("SurveyNotAvailable");
			
			private java.lang.String value;
			
			CodeEnum(java.lang.String v) {
				value = v;
			}
			
			@com.fasterxml.jackson.annotation.JsonValue
			public String value() {
				return value;
			}
			
			@Override
			public String toString() {
				return String.valueOf(value);
			}
			
			public static CodeEnum fromValue(String v) {
				for (CodeEnum b : CodeEnum.values()) {
					if (String.valueOf(b.value).equals(v)) {
						return b;
					}
				}
				return null;
			}
		}
		
		private com.example.model.ParticipationCompletionError.Message.CodeEnum code = null;
		private java.lang.String message = null;
		
		/**
		 */
		public Message code(com.example.model.ParticipationCompletionError.Message.CodeEnum code) {
			setCode(code);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("code")
		@javax.validation.constraints.NotNull
		public com.example.model.ParticipationCompletionError.Message.CodeEnum getCode() {
			return this.code;
		}
		public void setCode(com.example.model.ParticipationCompletionError.Message.CodeEnum code) {
			this.code = code;
		}
		
		/**
		 */
		public Message message(java.lang.String message) {
			setMessage(message);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("message")
		@javax.validation.constraints.NotNull
		public java.lang.String getMessage() {
			return this.message;
		}
		public void setMessage(java.lang.String message) {
			this.message = message;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Message message = (Message) o;
			return java.util.Objects.equals(this.code, message.code) &&
					java.util.Objects.equals(this.message, message.message);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.code, this.message);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Message {\n");
			
			sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
			sb.append("    message: ").append(toIndentedString(this.message)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.ParticipationCompletionError.Message> messages = new java.util.ArrayList<com.example.model.ParticipationCompletionError.Message>();
	
	/**
	 */
	public ParticipationCompletionError messages(java.util.List<com.example.model.ParticipationCompletionError.Message> messages) {
		setMessages(messages);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("messages")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.ParticipationCompletionError.Message> getMessages() {
		return this.messages;
	}
	public void setMessages(java.util.List<com.example.model.ParticipationCompletionError.Message> messages) {
		this.messages = messages;
	}
	public void addMessage(com.example.model.ParticipationCompletionError.Message message) {
		if (this.messages == null) {
			this.messages = new java.util.ArrayList<com.example.model.ParticipationCompletionError.Message>();
		}
		this.messages.add(message);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ParticipationCompletionError participationCompletionError = (ParticipationCompletionError) o;
		return java.util.Objects.equals(this.messages, participationCompletionError.messages);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.messages);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ParticipationCompletionError {\n");
		
		sb.append("    messages: ").append(toIndentedString(this.messages)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
