package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class RemoveParticipationsRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.List<java.util.UUID> participations = new java.util.ArrayList<java.util.UUID>();
	
	/**
	 * The participation ids.
	 */
	public RemoveParticipationsRequest participations(java.util.List<java.util.UUID> participations) {
		setParticipations(participations);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The participation ids.")
	@com.fasterxml.jackson.annotation.JsonProperty("participations")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<java.util.UUID> getParticipations() {
		return this.participations;
	}
	public void setParticipations(java.util.List<java.util.UUID> participations) {
		this.participations = participations;
	}
	public void addParticipation(java.util.UUID participation) {
		if (this.participations == null) {
			this.participations = new java.util.ArrayList<java.util.UUID>();
		}
		this.participations.add(participation);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		RemoveParticipationsRequest removeParticipationsRequest = (RemoveParticipationsRequest) o;
		return java.util.Objects.equals(this.participations, removeParticipationsRequest.participations);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.participations);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class RemoveParticipationsRequest {\n");
		
		sb.append("    participations: ").append(toIndentedString(this.participations)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
