package com.example.model;

/**
 * A survey template that can be used to create a survey
 */
@io.swagger.annotations.ApiModel(value = "SurveyTemplate", description = "A survey template that can be used to create a survey")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyTemplate")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyTemplate implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	
	/**
	 */
	public SurveyTemplate id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public SurveyTemplate name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyTemplate surveyTemplate = (SurveyTemplate) o;
		return java.util.Objects.equals(this.id, surveyTemplate.id) &&
				java.util.Objects.equals(this.name, surveyTemplate.name);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyTemplate {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
