package com.example.model;

/**
 * A content library topic.
 */
@io.swagger.annotations.ApiModel(value = "Topic", description = "A content library topic.")
@javax.xml.bind.annotation.XmlRootElement(name = "Topic")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Topic extends com.example.model.TopicSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.List<java.util.UUID> featuredArticleIds = null;
	private com.example.model.TopicSummary parentTopic = null;
	private java.util.List<com.example.model.TopicSummary> topics = null;
	
	/**
	 */
	@java.lang.Override
	public Topic id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public Topic name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public Topic description(java.lang.String description) {
		setDescription(description);
		return this;
	}
	
	/**
	 */
	public Topic featuredArticleIds(java.util.List<java.util.UUID> featuredArticleIds) {
		setFeaturedArticleIds(featuredArticleIds);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("featuredArticleIds")
	@javax.validation.Valid
	public java.util.List<java.util.UUID> getFeaturedArticleIds() {
		return this.featuredArticleIds;
	}
	public void setFeaturedArticleIds(java.util.List<java.util.UUID> featuredArticleIds) {
		this.featuredArticleIds = featuredArticleIds;
	}
	public void addFeaturedArticleId(java.util.UUID featuredArticleId) {
		if (this.featuredArticleIds == null) {
			this.featuredArticleIds = new java.util.ArrayList<java.util.UUID>();
		}
		this.featuredArticleIds.add(featuredArticleId);
	}
	
	/**
	 * A content library topic.
	 */
	public Topic parentTopic(com.example.model.TopicSummary parentTopic) {
		setParentTopic(parentTopic);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A content library topic.")
	@com.fasterxml.jackson.annotation.JsonProperty("parentTopic")
	@javax.validation.Valid
	public com.example.model.TopicSummary getParentTopic() {
		return this.parentTopic;
	}
	public void setParentTopic(com.example.model.TopicSummary parentTopic) {
		this.parentTopic = parentTopic;
	}
	
	/**
	 */
	public Topic topics(java.util.List<com.example.model.TopicSummary> topics) {
		setTopics(topics);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("topics")
	@javax.validation.Valid
	public java.util.List<com.example.model.TopicSummary> getTopics() {
		return this.topics;
	}
	public void setTopics(java.util.List<com.example.model.TopicSummary> topics) {
		this.topics = topics;
	}
	public void addTopic(com.example.model.TopicSummary topic) {
		if (this.topics == null) {
			this.topics = new java.util.ArrayList<com.example.model.TopicSummary>();
		}
		this.topics.add(topic);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		Topic topic = (Topic) o;
		return java.util.Objects.equals(this.featuredArticleIds, topic.featuredArticleIds) &&
				java.util.Objects.equals(this.parentTopic, topic.parentTopic) &&
				java.util.Objects.equals(this.topics, topic.topics);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.featuredArticleIds, this.parentTopic, this.topics);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Topic {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    featuredArticleIds: ").append(toIndentedString(this.featuredArticleIds)).append("\n");
		sb.append("    parentTopic: ").append(toIndentedString(this.parentTopic)).append("\n");
		sb.append("    topics: ").append(toIndentedString(this.topics)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
