package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AddAccountParticipantsRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Participant implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String givenName = null;
		private java.lang.String familyName = null;
		private java.lang.String emailAddress = null;
		
		/**
		 */
		public Participant givenName(java.lang.String givenName) {
			setGivenName(givenName);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("givenName")
		public java.lang.String getGivenName() {
			return this.givenName;
		}
		public void setGivenName(java.lang.String givenName) {
			this.givenName = givenName;
		}
		
		/**
		 */
		public Participant familyName(java.lang.String familyName) {
			setFamilyName(familyName);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("familyName")
		public java.lang.String getFamilyName() {
			return this.familyName;
		}
		public void setFamilyName(java.lang.String familyName) {
			this.familyName = familyName;
		}
		
		/**
		 */
		public Participant emailAddress(java.lang.String emailAddress) {
			setEmailAddress(emailAddress);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("emailAddress")
		@javax.validation.constraints.NotNull
		@javax.validation.constraints.Email
		public java.lang.String getEmailAddress() {
			return this.emailAddress;
		}
		public void setEmailAddress(java.lang.String emailAddress) {
			this.emailAddress = emailAddress;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Participant participant = (Participant) o;
			return java.util.Objects.equals(this.givenName, participant.givenName) &&
					java.util.Objects.equals(this.familyName, participant.familyName) &&
					java.util.Objects.equals(this.emailAddress, participant.emailAddress);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.givenName, this.familyName, this.emailAddress);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Participant {\n");
			
			sb.append("    givenName: ").append(toIndentedString(this.givenName)).append("\n");
			sb.append("    familyName: ").append(toIndentedString(this.familyName)).append("\n");
			sb.append("    emailAddress: ").append(toIndentedString(this.emailAddress)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.AddAccountParticipantsRequest.Participant> participants = new java.util.ArrayList<com.example.model.AddAccountParticipantsRequest.Participant>();
	private java.util.UUID group = null;
	
	/**
	 */
	public AddAccountParticipantsRequest participants(java.util.List<com.example.model.AddAccountParticipantsRequest.Participant> participants) {
		setParticipants(participants);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("participants")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.AddAccountParticipantsRequest.Participant> getParticipants() {
		return this.participants;
	}
	public void setParticipants(java.util.List<com.example.model.AddAccountParticipantsRequest.Participant> participants) {
		this.participants = participants;
	}
	public void addParticipant(com.example.model.AddAccountParticipantsRequest.Participant participant) {
		if (this.participants == null) {
			this.participants = new java.util.ArrayList<com.example.model.AddAccountParticipantsRequest.Participant>();
		}
		this.participants.add(participant);
	}
	
	/**
	 */
	public AddAccountParticipantsRequest group(java.util.UUID group) {
		setGroup(group);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("group")
	public java.util.UUID getGroup() {
		return this.group;
	}
	public void setGroup(java.util.UUID group) {
		this.group = group;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		AddAccountParticipantsRequest addAccountParticipantsRequest = (AddAccountParticipantsRequest) o;
		return java.util.Objects.equals(this.participants, addAccountParticipantsRequest.participants) &&
				java.util.Objects.equals(this.group, addAccountParticipantsRequest.group);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.participants, this.group);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AddAccountParticipantsRequest {\n");
		
		sb.append("    participants: ").append(toIndentedString(this.participants)).append("\n");
		sb.append("    group: ").append(toIndentedString(this.group)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
