package com.example.model;

@io.swagger.annotations.ApiModel(value = "EmailLoginTokenRequest")
@javax.xml.bind.annotation.XmlRootElement(name = "EmailLoginTokenRequest")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class EmailLoginTokenRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String email = null;
	
	/**
	 * user email to send login/participation link to
	 */
	public EmailLoginTokenRequest email(java.lang.String email) {
		setEmail(email);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "user email to send login/participation link to")
	@com.fasterxml.jackson.annotation.JsonProperty("email")
	public java.lang.String getEmail() {
		return this.email;
	}
	public void setEmail(java.lang.String email) {
		this.email = email;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		EmailLoginTokenRequest emailLoginTokenRequest = (EmailLoginTokenRequest) o;
		return java.util.Objects.equals(this.email, emailLoginTokenRequest.email);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.email);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class EmailLoginTokenRequest {\n");
		
		sb.append("    email: ").append(toIndentedString(this.email)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
