package com.example.model;

@io.swagger.annotations.ApiModel(value = "")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class GetGroups200Response implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Group extends com.example.model.ParticipantGroup implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private int countInSurvey = 0;
		
		/**
		 */
		@java.lang.Override
		public Group id(java.util.UUID id) {
			setId(id);
			return this;
		}
		
		/**
		 */
		@java.lang.Override
		public Group name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		/**
		 * The number of participants in the group.
		 */
		@java.lang.Override
		public Group count(int count) {
			setCount(count);
			return this;
		}
		
		/**
		 */
		@java.lang.Override
		public Group groupType(com.example.model.ParticipantGroup.GroupTypeEnum groupType) {
			setGroupType(groupType);
			return this;
		}
		
		/**
		 */
		@java.lang.Override
		public Group canDelete(boolean canDelete) {
			setCanDelete(canDelete);
			return this;
		}
		
		/**
		 * The number of participants in this group who are already participants of this survey
		 */
		public Group countInSurvey(int countInSurvey) {
			setCountInSurvey(countInSurvey);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The number of participants in this group who are already participants of this survey")
		@com.fasterxml.jackson.annotation.JsonProperty("countInSurvey")
		@javax.validation.constraints.NotNull
		public int getCountInSurvey() {
			return this.countInSurvey;
		}
		public void setCountInSurvey(int countInSurvey) {
			this.countInSurvey = countInSurvey;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			if (!super.equals(o)) {
				return false;
			}
			Group group = (Group) o;
			return java.util.Objects.equals(this.countInSurvey, group.countInSurvey);
		}
		
		@Override
		public int hashCode() {
			return 31 * super.hashCode() + java.util.Objects.hash(this.countInSurvey);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Group {\n");
			sb.append("    ").append(toIndentedString(super.toString())).append("\n");
			sb.append("    countInSurvey: ").append(toIndentedString(this.countInSurvey)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.GetGroups200Response.Group> groups = new java.util.ArrayList<com.example.model.GetGroups200Response.Group>();
	
	/**
	 */
	public GetGroups200Response groups(java.util.List<com.example.model.GetGroups200Response.Group> groups) {
		setGroups(groups);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("groups")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.GetGroups200Response.Group> getGroups() {
		return this.groups;
	}
	public void setGroups(java.util.List<com.example.model.GetGroups200Response.Group> groups) {
		this.groups = groups;
	}
	public void addGroup(com.example.model.GetGroups200Response.Group group) {
		if (this.groups == null) {
			this.groups = new java.util.ArrayList<com.example.model.GetGroups200Response.Group>();
		}
		this.groups.add(group);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		GetGroups200Response getGroups200Response = (GetGroups200Response) o;
		return java.util.Objects.equals(this.groups, getGroups200Response.groups);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.groups);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class GetGroups200Response {\n");
		
		sb.append("    groups: ").append(toIndentedString(this.groups)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
