package com.example.model;

/**
 * Information about a person who can be a participant in a survey. Represents a Person with a Role of Participant in our database model.
 */
@io.swagger.annotations.ApiModel(value = "Participant", description = "Information about a person who can be a participant in a survey. Represents a Person with a Role of Participant in our database model.")
@javax.xml.bind.annotation.XmlRootElement(name = "Participant")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Participant implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String givenName = null;
	private java.lang.String familyName = null;
	private java.lang.String emailAddress = null;
	
	/**
	 */
	public Participant id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public Participant givenName(java.lang.String givenName) {
		setGivenName(givenName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("givenName")
	public java.lang.String getGivenName() {
		return this.givenName;
	}
	public void setGivenName(java.lang.String givenName) {
		this.givenName = givenName;
	}
	
	/**
	 */
	public Participant familyName(java.lang.String familyName) {
		setFamilyName(familyName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("familyName")
	public java.lang.String getFamilyName() {
		return this.familyName;
	}
	public void setFamilyName(java.lang.String familyName) {
		this.familyName = familyName;
	}
	
	/**
	 */
	public Participant emailAddress(java.lang.String emailAddress) {
		setEmailAddress(emailAddress);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("emailAddress")
	@javax.validation.constraints.NotNull
	@javax.validation.constraints.Email
	public java.lang.String getEmailAddress() {
		return this.emailAddress;
	}
	public void setEmailAddress(java.lang.String emailAddress) {
		this.emailAddress = emailAddress;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		Participant participant = (Participant) o;
		return java.util.Objects.equals(this.id, participant.id) &&
				java.util.Objects.equals(this.givenName, participant.givenName) &&
				java.util.Objects.equals(this.familyName, participant.familyName) &&
				java.util.Objects.equals(this.emailAddress, participant.emailAddress);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.givenName, this.familyName, this.emailAddress);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Participant {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    givenName: ").append(toIndentedString(this.givenName)).append("\n");
		sb.append("    familyName: ").append(toIndentedString(this.familyName)).append("\n");
		sb.append("    emailAddress: ").append(toIndentedString(this.emailAddress)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
