package com.example.model;

@io.swagger.annotations.ApiModel(value = "ReportFilter")
@javax.xml.bind.annotation.XmlRootElement(name = "ReportFilter")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ReportFilter implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Question implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.util.UUID question = null;
		private java.util.List<java.lang.Integer> answers = new java.util.ArrayList<java.lang.Integer>();
		
		/**
		 */
		public Question question(java.util.UUID question) {
			setQuestion(question);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("question")
		@javax.validation.constraints.NotNull
		public java.util.UUID getQuestion() {
			return this.question;
		}
		public void setQuestion(java.util.UUID question) {
			this.question = question;
		}
		
		/**
		 */
		public Question answers(java.util.List<java.lang.Integer> answers) {
			setAnswers(answers);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("answers")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<java.lang.Integer> getAnswers() {
			return this.answers;
		}
		public void setAnswers(java.util.List<java.lang.Integer> answers) {
			this.answers = answers;
		}
		public void addAnswer(int answer) {
			if (this.answers == null) {
				this.answers = new java.util.ArrayList<java.lang.Integer>();
			}
			this.answers.add(answer);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Question question = (Question) o;
			return java.util.Objects.equals(this.question, question.question) &&
					java.util.Objects.equals(this.answers, question.answers);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.question, this.answers);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Question {\n");
			
			sb.append("    question: ").append(toIndentedString(this.question)).append("\n");
			sb.append("    answers: ").append(toIndentedString(this.answers)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.List<com.example.model.ReportFilter.Question> questions = null;
	private java.util.List<java.util.UUID> participantGroups = null;
	
	/**
	 */
	public ReportFilter questions(java.util.List<com.example.model.ReportFilter.Question> questions) {
		setQuestions(questions);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("questions")
	@javax.validation.Valid
	public java.util.List<com.example.model.ReportFilter.Question> getQuestions() {
		return this.questions;
	}
	public void setQuestions(java.util.List<com.example.model.ReportFilter.Question> questions) {
		this.questions = questions;
	}
	public void addQuestion(com.example.model.ReportFilter.Question question) {
		if (this.questions == null) {
			this.questions = new java.util.ArrayList<com.example.model.ReportFilter.Question>();
		}
		this.questions.add(question);
	}
	
	/**
	 */
	public ReportFilter participantGroups(java.util.List<java.util.UUID> participantGroups) {
		setParticipantGroups(participantGroups);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("participantGroups")
	@javax.validation.Valid
	public java.util.List<java.util.UUID> getParticipantGroups() {
		return this.participantGroups;
	}
	public void setParticipantGroups(java.util.List<java.util.UUID> participantGroups) {
		this.participantGroups = participantGroups;
	}
	public void addParticipantGroup(java.util.UUID participantGroup) {
		if (this.participantGroups == null) {
			this.participantGroups = new java.util.ArrayList<java.util.UUID>();
		}
		this.participantGroups.add(participantGroup);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ReportFilter reportFilter = (ReportFilter) o;
		return java.util.Objects.equals(this.questions, reportFilter.questions) &&
				java.util.Objects.equals(this.participantGroups, reportFilter.participantGroups);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.questions, this.participantGroups);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ReportFilter {\n");
		
		sb.append("    questions: ").append(toIndentedString(this.questions)).append("\n");
		sb.append("    participantGroups: ").append(toIndentedString(this.participantGroups)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
