package com.example.model;

/**
 * Provides summary information for a survey report section.
 */
@io.swagger.annotations.ApiModel(value = "SurveyReportSectionSummaryItem", description = "Provides summary information for a survey report section.")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportSectionSummaryItem")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportSectionSummaryItem implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String name = null;
	private java.lang.String code = null;
	private java.lang.String icon = null;
	private java.math.BigDecimal score = null;
	private java.math.BigDecimal minRatio = new java.math.BigDecimal("0");
	private java.math.BigDecimal midRatio = new java.math.BigDecimal("0");
	private java.math.BigDecimal maxRatio = new java.math.BigDecimal("0");
	private java.lang.String minLabel = null;
	private java.lang.String midLabel = null;
	private java.lang.String maxLabel = null;
	
	/**
	 */
	public SurveyReportSectionSummaryItem name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem code(java.lang.String code) {
		setCode(code);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("code")
	public java.lang.String getCode() {
		return this.code;
	}
	public void setCode(java.lang.String code) {
		this.code = code;
	}
	
	/**
	 * The name of the icon to use for this aspect, if any.
	 */
	public SurveyReportSectionSummaryItem icon(java.lang.String icon) {
		setIcon(icon);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The name of the icon to use for this aspect, if any.")
	@com.fasterxml.jackson.annotation.JsonProperty("icon")
	public java.lang.String getIcon() {
		return this.icon;
	}
	public void setIcon(java.lang.String icon) {
		this.icon = icon;
	}
	
	/**
	 * Score between 0.0 and 1.0
	 */
	public SurveyReportSectionSummaryItem score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Score between 0.0 and 1.0")
	@com.fasterxml.jackson.annotation.JsonProperty("score")
	public java.math.BigDecimal getScore() {
		return this.score;
	}
	public void setScore(java.math.BigDecimal score) {
		this.score = score;
	}
	
	/**
	 * The ratio of all respondents who are in the min group.
	 */
	public SurveyReportSectionSummaryItem minRatio(java.math.BigDecimal minRatio) {
		setMinRatio(minRatio);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The ratio of all respondents who are in the min group.")
	@com.fasterxml.jackson.annotation.JsonProperty("minRatio")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getMinRatio() {
		return this.minRatio;
	}
	public void setMinRatio(java.math.BigDecimal minRatio) {
		this.minRatio = minRatio;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem midRatio(java.math.BigDecimal midRatio) {
		setMidRatio(midRatio);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("midRatio")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getMidRatio() {
		return this.midRatio;
	}
	public void setMidRatio(java.math.BigDecimal midRatio) {
		this.midRatio = midRatio;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem maxRatio(java.math.BigDecimal maxRatio) {
		setMaxRatio(maxRatio);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("maxRatio")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getMaxRatio() {
		return this.maxRatio;
	}
	public void setMaxRatio(java.math.BigDecimal maxRatio) {
		this.maxRatio = maxRatio;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("minLabel")
	public java.lang.String getMinLabel() {
		return this.minLabel;
	}
	public void setMinLabel(java.lang.String minLabel) {
		this.minLabel = minLabel;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("midLabel")
	public java.lang.String getMidLabel() {
		return this.midLabel;
	}
	public void setMidLabel(java.lang.String midLabel) {
		this.midLabel = midLabel;
	}
	
	/**
	 */
	public SurveyReportSectionSummaryItem maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("maxLabel")
	public java.lang.String getMaxLabel() {
		return this.maxLabel;
	}
	public void setMaxLabel(java.lang.String maxLabel) {
		this.maxLabel = maxLabel;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyReportSectionSummaryItem surveyReportSectionSummaryItem = (SurveyReportSectionSummaryItem) o;
		return java.util.Objects.equals(this.name, surveyReportSectionSummaryItem.name) &&
				java.util.Objects.equals(this.code, surveyReportSectionSummaryItem.code) &&
				java.util.Objects.equals(this.icon, surveyReportSectionSummaryItem.icon) &&
				java.util.Objects.equals(this.score, surveyReportSectionSummaryItem.score) &&
				java.util.Objects.equals(this.minRatio, surveyReportSectionSummaryItem.minRatio) &&
				java.util.Objects.equals(this.midRatio, surveyReportSectionSummaryItem.midRatio) &&
				java.util.Objects.equals(this.maxRatio, surveyReportSectionSummaryItem.maxRatio) &&
				java.util.Objects.equals(this.minLabel, surveyReportSectionSummaryItem.minLabel) &&
				java.util.Objects.equals(this.midLabel, surveyReportSectionSummaryItem.midLabel) &&
				java.util.Objects.equals(this.maxLabel, surveyReportSectionSummaryItem.maxLabel);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.name, this.code, this.icon, this.score, this.minRatio, this.midRatio, this.maxRatio, this.minLabel, this.midLabel, this.maxLabel);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportSectionSummaryItem {\n");
		
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
		sb.append("    icon: ").append(toIndentedString(this.icon)).append("\n");
		sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
		sb.append("    minRatio: ").append(toIndentedString(this.minRatio)).append("\n");
		sb.append("    midRatio: ").append(toIndentedString(this.midRatio)).append("\n");
		sb.append("    maxRatio: ").append(toIndentedString(this.maxRatio)).append("\n");
		sb.append("    minLabel: ").append(toIndentedString(this.minLabel)).append("\n");
		sb.append("    midLabel: ").append(toIndentedString(this.midLabel)).append("\n");
		sb.append("    maxLabel: ").append(toIndentedString(this.maxLabel)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
