package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReportSummary")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportSummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.SurveyReport.class, name = "SurveyReport"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.lang.String surveyName = null;
	private java.math.BigDecimal score = new java.math.BigDecimal("0");
	private com.example.model.SurveyDetails details = null;
	
	/**
	 * the name of survey this report is for
	 */
	public SurveyReportSummary surveyName(java.lang.String surveyName) {
		setSurveyName(surveyName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "the name of survey this report is for")
	@com.fasterxml.jackson.annotation.JsonProperty("surveyName")
	public java.lang.String getSurveyName() {
		return this.surveyName;
	}
	public void setSurveyName(java.lang.String surveyName) {
		this.surveyName = surveyName;
	}
	
	/**
	 * Score between 0.0 and 1.0
	 */
	public SurveyReportSummary score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "Score between 0.0 and 1.0")
	@com.fasterxml.jackson.annotation.JsonProperty("score")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getScore() {
		return this.score;
	}
	public void setScore(java.math.BigDecimal score) {
		this.score = score;
	}
	
	/**
	 */
	public SurveyReportSummary details(com.example.model.SurveyDetails details) {
		setDetails(details);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("details")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.SurveyDetails getDetails() {
		return this.details;
	}
	public void setDetails(com.example.model.SurveyDetails details) {
		this.details = details;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyReportSummary surveyReportSummary = (SurveyReportSummary) o;
		return java.util.Objects.equals(this.surveyName, surveyReportSummary.surveyName) &&
				java.util.Objects.equals(this.score, surveyReportSummary.score) &&
				java.util.Objects.equals(this.details, surveyReportSummary.details);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.surveyName, this.score, this.details);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportSummary {\n");
		
		sb.append("    surveyName: ").append(toIndentedString(this.surveyName)).append("\n");
		sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
		sb.append("    details: ").append(toIndentedString(this.details)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
