package com.example.model;

@io.swagger.annotations.ApiModel(value = "UserDetails")
@javax.xml.bind.annotation.XmlRootElement(name = "UserDetails")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class UserDetails extends com.example.model.PersonSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private com.example.model.AdminUserRole adminRole = null;
	
	/**
	 */
	@java.lang.Override
	public UserDetails id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public UserDetails name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public UserDetails givenName(java.lang.String givenName) {
		setGivenName(givenName);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public UserDetails familyName(java.lang.String familyName) {
		setFamilyName(familyName);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public UserDetails emailAddress(java.lang.String emailAddress) {
		setEmailAddress(emailAddress);
		return this;
	}
	
	/**
	 */
	public UserDetails adminRole(com.example.model.AdminUserRole adminRole) {
		setAdminRole(adminRole);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("adminRole")
	@javax.validation.constraints.NotNull
	public com.example.model.AdminUserRole getAdminRole() {
		return this.adminRole;
	}
	public void setAdminRole(com.example.model.AdminUserRole adminRole) {
		this.adminRole = adminRole;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		UserDetails userDetails = (UserDetails) o;
		return java.util.Objects.equals(this.adminRole, userDetails.adminRole);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.adminRole);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class UserDetails {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    adminRole: ").append(toIndentedString(this.adminRole)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
